<!DOCTYPE html>
<html>
<head>
  <meta charset="utf-8" />
  <title>ITEA-JS ADVANCED - LESSON 2: CLASSWORK 2</title>
  <link rel="stylesheet" href="css/style.min.css" />
</head>
<body>
  <div class="wrap">
    <div class="testBlock hover">
      <button class="iButton" id="mouseHover">Наведи</button>
      <ul id="hoverResult" class="resultBlock">
      </ul>
    </div>

    <div class="testBlock click">
      <button class="iButton" id="mouseClick">Нажми левой кнопкой мышки</button>
      <div id="clickResult" class="resultBlock one two three four five six"></div>
    </div>

    <div class="testBlock context">
      <button class="iButton" id="mouseContext">Вызови контекстное меню</button>
      <div id="contextResult" class="resultBlock"></div>
    </div>

    <div class="testBlock keyboard">
      <button class="iButton" id="keyboardButton">Нажми на клавиатуре</button>
      <div id="keyboardResult" class="resultBlock"></div>
    </div>

  </div>

  <script>
    /*

      Поработаем немного с ивентами:
      onmouseenter
      onclick
      oncontextmenu
      onkeydown

      Задание:
      На каждую из конопок назначить действие которое будет выполнять следующее действие:
      1.На ховер(onmouseenter) повесить обработчик который будет при каждом наведении
        на кнопку будет выводить в блок результатом елемент li с текстом "hovered!"
        у которого будет один из следующих класов:
        red blue green orange purple

      2.На кнопку клика(onclick) повесить обработчик который будет удалять классы с
        блока с результатом по очереди в таком порядке:

        six > two > three > four > one > five

        после того как блок окажется пустым, добавить их в порядке возрастания

        one > two > three ... > six

      3.На кнопку контекстного меню (oncontextmenu) повесить обработчик который в блок
        для результата выведет блок со списком меню используя следующий шаблон:

        <a href="http://google.com.ua">Google</a>
        <a href="http://itea.ua/">ITEA</a>
        <a href="https://www.youtube.com/">Youtube</a>

        для запрета вызова контектстного меню, нужно в функцию обработчик передать событие
        element.onevent = function(e){...}
        и вызвать внутри этой функции из этой переменной
        e.preventDefault(); <- Отмена действия по умолчанию

        Повтороное кажатие на эту кнопку правой или левой кнопкой мыши должно очистить блок.

      4. На кнопку с обработчиком нажатия (onkeydown) повесить обработчик который будет
        Выводить число нажатий на любую из клавиш клавиатуры


    */

   function getRandomIntInclusive(min, max) {
    min = Math.ceil(min);
    max = Math.floor(max);
    return Math.floor(Math.random() * (max - min + 1)) + min;
  }

    var mouseHover = document.getElementById("mouseHover");
    var mouseClick = document.getElementById("mouseClick");
    var mouseContext = document.getElementById("mouseContext");
    var keyboardButton = document.getElementById("keyboardButton");

    var colors = ['red', 'blue', 'green', 'orange', 'purple'];

    var masForvard = ['six','two','three','four','one','five'];
    var masReverse = ['one','two','three','four','five','six'];

    mouseHover.onmouseenter = function(e){
      var random = getRandomIntInclusive(0,4);
      var elem = document.createElement('li');          
      elem.className =colors[random];
      elem.innerText = 'color: '+colors[random];
      var hoverResult = document.getElementById('hoverResult');
      hoverResult.appendChild(elem);
    }

    var clickIndex = 0;
    var direction = true;
    mouseClick.onclick = function(){
      var clickResult = document.getElementById('clickResult');      
      console.log(clickIndex);
      if(direction){
        clickResult.classList.remove(masForvard[clickIndex]);
        clickIndex++;
      }
      else {
        clickResult.classList.add(masReverse[clickIndex]);
        clickIndex++;
      }
      if(clickIndex==6){
          clickIndex=0;
          direction=!direction
        }
    }

    var showContext = false;
    mouseContext.onclick = function(e){
      console.log('click');
      document.getElementById('contextResult').innerHTML = '';
    }
    mouseContext.oncontextmenu = function(e){
        e.preventDefault();
        var contextResult = document.getElementById('contextResult');
        if(contextResult.innerHTML.length==0){

        var a1 = document.createElement('a');
        a1.href = 'http://google.com.ua';
        a1.innerText = 'Google';
        var a2 = document.createElement('a');
        a2.href = 'http://itea.ua/';
        a2.innerText = 'ITEA';
        // <a href="https://www.youtube';
        var a3 = document.createElement('a');
        a3.href = 'https://www.youtube.com/';
        a3.innerText = 'Youtube';

        contextResult.append(a1);
        contextResult.append(a2);
        contextResult.append(a3);
        }
        else {
          contextResult.innerHTML = '';
        }
    }

    var counter = 0;
    keyboardButton.onkeydown = function(){
      var keyboardResult = document.getElementById('keyboardResult');
      counter++;
      keyboardResult.innerText = counter;
        console.log('keydown'); 
    }
  </script>
</body>
</html>
